fs = require 'fs'
pass = require 'pass'


htpasswds = ->
    array = fs.readFileSync('/usr/fb/omgwww.htpasswd').toString().split("\n")
    htwds = {}
    for i of array
        split = array[i].split(":") or []
        htwds[split[0]] = split[1]
    return htwds

authenticator = (req, res, next) ->

    # check whether an autorization header was send

    # only accepting basic auth, so:
    # * cut the starting "Basic " from the header
    # * decode the base64 encoded username:password
    # * split the string at the colon
    # -> should result in an array
    tryAgain = ->

        # send an Basic Auth request (HTTP Code: 401 Unauthorized)
        res.statusCode = 401

        # MyRealmName can be changed to anything, will be prompted to the user
        res.setHeader "WWW-Authenticate", "Basic realm=\"OfficeMaster Gate\""

        # this will displayed in the browser when authorization is cancelled
        res.end "Unauthorized"
        return
    auth = undefined
    auth = new Buffer(req.headers.authorization.substring(6), "base64").toString().split(":")   if req.headers.authorization

    # checks if auth array exists
    if not auth or not auth[0] or not auth[1]
        tryAgain()
    else
        password = auth[1]
        username = auth[0]
        hash = htpasswds()[username]
        pass.validate password, hash, (error, success) ->
            if error
                logger.error "Login failed: " + error.message
                tryAgain()
            if success
                next()
            else #no erro, no success
                tryAgain()
            return

module.exports = authenticator